/**
This file is part of a project licensed under the GNU General Public License v3.
This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
GNU General Public License for more details.
You should have received a copy of the GNU General Public License
along with this program. If not, see <https://www.gnu.org/licenses/>.
*/

<template>
  <node-view-wrapper v-if="this.node.attrs.line.attributes" class="line">
    <!-- <div
    @mouseout="onMouseOut(node.attrs.line.attributes.id)" @mouseover="onMouseOver(node.attrs.line.attributes.id)"
      class="drag-handle"
      contenteditable="false"
      draggable="true"
      data-drag-handle
    /> -->
    <div
      @click="onMouseClick(node.attrs.line.attributes.id)"
      @dblclick="centerLine(node.attrs.line.attributes.id)"
      @mouseout="onMouseOut(node.attrs.line.attributes.id)"
      @mouseover="onMouseOver(node.attrs.line.attributes.id)"
    >
      <node-view-content :id="this.node.attrs.line.attributes.id">
      </node-view-content>
    </div>
  </node-view-wrapper>
</template>

<script>
import { NodeViewWrapper, NodeViewContent, nodeViewProps } from '@tiptap/vue-2'
import { mapState } from 'vuex'

export default {
  components: {
    NodeViewWrapper,
    NodeViewContent
  },
  methods: {
    highlight(id) {
      this.$store.dispatch('content/highlight', {
        target: id,
        origin: 'content'
      })
    },
    centerLine(id) {
      this.$store.dispatch('content/centerLine', {
        target: id,
        origin: 'content',
      })
    },
    select(id) {
      this.$store.dispatch('content/select', {
        target: id,
        origin: 'content'
      })
    },
    onMouseOver(id) {
      this.highlight(id)
    },
    onMouseOut(id) {
      this.highlight(id)
    },
    onMouseClick(id) {
      this.select(id)
    }
  },

  props: nodeViewProps
}
</script>
